<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class PtoBancohorasadmi extends \Doctrine\ORM\EntityRepository {
    
    public function getBancoHorasNaAdmissao($nrorg, $nrtipovinculom, $nrestrutlegal, $nrestrutgeren, $nrestrutsind, $nrocupacaom) {
        $bancosDeHorasAdmissaoComFiltrosEspecificos = $this->getBancoHorasFiltrosEspecificos(
            $nrorg, $nrtipovinculom, $nrestrutlegal, $nrestrutgeren, $nrestrutsind, $nrocupacaom
        );
        
        /* Verifica se existem bancos com filtros especificos preenchidos */
        
        $existemBancosEspecificos = count($bancosDeHorasAdmissaoComFiltrosEspecificos) > 0;
        if ($existemBancosEspecificos) {
            return $bancosDeHorasAdmissaoComFiltrosEspecificos;
        }
        
        /* Retorna ocorrencias sem filtros preenchidos se nao houverem registros com filtros especificos (defaults) */
        
        return $this->getBancoHorasSemFiltrosEspecificos($nrorg, $nrtipovinculom);
    }
    
    public function getBancoHorasFiltrosEspecificos($nrorg, $nrtipovinculom, $nrestrutlegal, $nrestrutgeren, $nrestrutsind, $nrocupacaom) {
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array(
            'P_NRORG'           => $nrorg, 
            'P_NRTIPOVINCULOM'  => $nrtipovinculom,
            'P_NRESTRUTLEGAL'   => $nrestrutlegal,
            'P_NRESTRUTGEREN'   => $nrestrutgeren,
            'P_NRESTRUTSIND'    => $nrestrutsind,
            'P_NROCUPACAOM'     => $nrocupacaom,
        );

$sql = <<<SQL
    SELECT BHA.*
FROM PTO_BANCOHORASADMI BHA
WHERE BHA.NRORG = :P_NRORG
    AND BHA.NRTIPOVINCULOM = :P_NRTIPOVINCULOM
    AND ( INSTR( ',' || BHA.NRESTRUTLEGAL    || ',', ','    || :P_NRESTRUTLEGAL    ||  ','  ) > 0 OR BHA.NRESTRUTLEGAL IS NULL )
    AND ( INSTR( ',' || BHA.NRESTRUTGEREN    || ',', ','    || :P_NRESTRUTGEREN    ||  ','  ) > 0 OR BHA.NRESTRUTGEREN IS NULL )
    AND ( INSTR( ',' || BHA.NRESTRUTSIND     || ',', ','    || :P_NRESTRUTSIND     ||  ','  ) > 0 OR BHA.NRESTRUTSIND  IS NULL )
    AND ( INSTR( ',' || BHA.NROCUPACAOM      || ',', ','    || :P_NROCUPACAOM      ||  ','  ) > 0 OR BHA.NROCUPACAOM   IS NULL )
    AND ( BHA.NRESTRUTLEGAL IS NOT NULL OR BHA.NRESTRUTGEREN IS NOT NULL OR BHA.NRESTRUTSIND IS NOT NULL OR BHA.NROCUPACAOM IS NOT NULL )
    AND BHA.IDATIVO = 'S'
SQL;

        $result = $db->fetchAll($sql,$params);

        return $result;
    }
    
    public function getBancoHorasSemFiltrosEspecificos($nrorg, $nrtipovinculom){
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array(
            'P_NRORG'           => $nrorg, 
            'P_NRTIPOVINCULOM'  => $nrtipovinculom
        );

$sql = <<<SQL
    SELECT BHA.*
FROM PTO_BANCOHORASADMI BHA
WHERE BHA.NRORG = :P_NRORG
    AND BHA.NRTIPOVINCULOM = :P_NRTIPOVINCULOM
    AND BHA.NRESTRUTLEGAL IS NULL
    AND BHA.NRESTRUTGEREN IS NULL
    AND BHA.NRESTRUTSIND IS NULL
    AND BHA.NROCUPACAOM IS NULL
    AND BHA.IDATIVO = 'S'
SQL;

        $result = $db->fetchAll($sql,$params);

        return $result;
    }

    
}